import 'package:doctor_app_flutter/core/viewModel/procedure_View_model.dart';
import 'package:doctor_app_flutter/models/patient/patiant_info_model.dart';
import 'package:doctor_app_flutter/screens/base/base_view.dart';
import 'package:doctor_app_flutter/screens/patients/profile/lab_result/laboratory_result_page.dart';
import 'package:doctor_app_flutter/screens/procedures/add_lab_orders.dart';
import 'package:doctor_app_flutter/util/translations_delegate_base.dart';
import 'package:doctor_app_flutter/widgets/patients/profile/add-order/addNewOrder.dart';
import 'package:doctor_app_flutter/widgets/patients/profile/patient-profile-header-new-design-app-bar.dart';
import 'package:doctor_app_flutter/widgets/shared/app_scaffold_widget.dart';
import 'package:doctor_app_flutter/widgets/shared/app_texts_widget.dart';
import 'package:doctor_app_flutter/widgets/shared/doctor_card.dart';
import 'package:doctor_app_flutter/widgets/transitions/fade_page.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class LabsHomePage extends StatefulWidget {
  @override
  _LabsHomePageState createState() => _LabsHomePageState();
}

class _LabsHomePageState extends State<LabsHomePage> {
  String patientType;

  String arrivalType;
  PatiantInformtion patient;
  bool isInpatient;
  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    final routeArgs = ModalRoute.of(context).settings.arguments as Map;
    patient = routeArgs['patient'];
    patientType = routeArgs['patientType'];
    arrivalType = routeArgs['arrivalType'];
    isInpatient = routeArgs['isInpatient'];
    print(arrivalType);
  }

  @override
  Widget build(BuildContext context) {
    return BaseView<ProcedureViewModel>(
      onModelReady: (model) => model.getLabs(patient, isInpatient: false),
      builder: (context, ProcedureViewModel model, widget) => AppScaffold(
        baseViewModel: model,
        backgroundColor: Colors.grey[100],
        isShowAppBar: true,
        appBar: PatientProfileHeaderNewDesignAppBar(
            patient, patient.patientType.toString() ?? '0', patientType),
        body: SingleChildScrollView(
          physics: BouncingScrollPhysics(),
          child: FractionallySizedBox(
            widthFactor: 1.0,
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                SizedBox(
                  height: 12,
                ),
                if(model.patientLabOrdersList.isNotEmpty && patient.patientStatusType != 43)
                Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      AppText(
                        'Lab',
                        style: "caption2",
                        color: Colors.black,
                        fontSize: 13,
                      ),
                      AppText(
                        'Result',
                        bold: true,
                        fontSize: 22,
                      ),
                    ],
                  ),
                ),
                if ( patient.patientStatusType!=null && patient.patientStatusType == 43)
                  Padding(
                    padding: const EdgeInsets.all(8.0),
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        AppText(
                          'Lab',
                          style: "caption2",
                          color: Colors.black,
                          fontSize: 13,
                        ),
                        AppText(
                          'Result',
                          bold: true,
                          fontSize: 22,
                        ),
                      ],
                    ),
                  ),
                if ( patient.patientStatusType!=null && patient.patientStatusType == 43)
                AddNewOrder( onTap: () {
                  Navigator.push(
                    context,
                    MaterialPageRoute(
                        builder: (context) => AddSelectedLabOrder(
                          patient: patient,
                          model: model,
                        )),
                  );
                },label: 'Apply for New Lab Order',),

                ...List.generate(
                  model.patientLabOrdersList.length,
                  (index) => Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: model
                        .patientLabOrdersList[index].patientLabOrdersList
                        .map((labOrder) {
                      return Container(
                          margin: EdgeInsets.all(10),
                          decoration: BoxDecoration(
                              border: Border.all(
                                width: 0.5,
                                color: Colors.white,
                              ),
                              borderRadius: BorderRadius.all(
                                Radius.circular(8.0),
                              ),
                              color: Colors.white),
                        child: Row(
                          children: [
                            Container(
                              width: 20,
                              height: 160,
                              decoration: BoxDecoration(
                                //Colors.red[900]  Color(0xff404545)
                                color: labOrder.isLiveCareAppointment
                                    ? Colors.red[900]
                                    : !labOrder.isInOutPatient
                                    ? Colors.black
                                    : Color(0xffa9a089),
                                borderRadius: BorderRadius.only(
                                  topLeft: Radius.circular(8),
                                  bottomLeft: Radius.circular(8),

                                ),
                              ),
                              child: RotatedBox(
                                  quarterTurns: 3,
                                  child: Center(
                                    child: Text(
                                      labOrder.isLiveCareAppointment
                                          ? TranslationBase.of(context)
                                          .liveCare
                                          .toUpperCase()
                                          : !labOrder.isInOutPatient
                                          ? TranslationBase.of(context)
                                          .inPatient
                                          .toUpperCase()
                                          : TranslationBase.of(context)
                                          .outpatient
                                          .toUpperCase(),
                                      style: TextStyle(color: Colors.white),
                                    ),
                                  )),
                            ),
                            Expanded(
                              child: DoctorCard(
                                isNoMargin: true,
                                onTap: () => Navigator.push(
                                  context,
                                  FadePage(
                                    page: LaboratoryResultPage(
                                      patientLabOrders: labOrder,
                                      patient: patient,
                                      arrivalType: arrivalType,
                                      patientType: patientType,
                                    ),
                                  ),
                                ),
                                doctorName: labOrder.doctorName,
                                invoiceNO: ' ${labOrder.invoiceNo}',
                                profileUrl: labOrder.doctorImageURL,
                                branch: labOrder.projectName,
                                clinic: labOrder.clinicDescription,
                                appointmentDate: labOrder.orderDate,
                                orderNo: labOrder.orderNo,
                                isShowTime: false,
                              ),
                            ),
                          ],
                        ),
                      );
                    }).toList(),
                  ),
                ),
                if(model.patientLabOrdersList.isEmpty && patient.patientStatusType != 43)
                  Center(
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.center,
                      children: [
                        SizedBox(height: 100,),
                        Image.asset('assets/images/no-data.png'),
                        Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: AppText('No Lab Result Found'),
                        )

                      ],
                    ),
                  )
              ],
            ),
          ),
        ),
      ),
    );
  }
}
